--- chrome/chrome.gyp
+++ chrome/chrome.gyp
@@ -459,7 +459,7 @@
         '../base/base.gyp:base',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': ['../build/linux/system.gyp:gtk'],
         }],
       ],
@@ -734,7 +734,7 @@
         '../app/app.gyp:app_base',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
           ],
@@ -748,7 +748,7 @@
               '-lXext',
             ],
           },
-        }, { # else: 'OS!="linux"'
+        }, { # else: 'OS!="linux" and OS!="freebsd"'
           'sources!': [
             'third_party/xdg_user_dirs/xdg_user_dir_lookup.cc',
           ],
@@ -767,7 +767,7 @@
             'common/temp_scaffolding_stubs.h',
           ],
         }],
-        ['OS=="win" or OS=="linux"', {
+        ['OS=="win" or OS=="linux" or OS=="freebsd"', {
           'sources!': [
             'common/temp_scaffolding_stubs.cc',
           ],
@@ -2542,7 +2542,7 @@
             ['exclude', '^browser/chromeos'],
           ],
         }],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             # Temporarily disabled while we figure some stuff out.
             # http://code.google.com/p/chromium/issues/detail?id=12351
@@ -2572,7 +2572,7 @@
             ['include', '^browser/printing/page_(number|range|setup)\\.cc$'],
           ],
           'conditions': [
-            ['linux_breakpad==1', {
+            ['OS=="linux" and linux_breakpad==1', {
               'sources': [
                 'app/breakpad_linux.cc',
                 'app/breakpad_linux.h',
@@ -2592,19 +2592,13 @@
             }],
           ],
         }],
-        ['OS=="linux" and toolkit_views==0', {
+        ['(OS=="linux" or OS=="freebsd") and toolkit_views==0', {
           'sources!': [
             'browser/bookmarks/bookmark_drop_info.cc',
             'browser/views/autocomplete/autocomplete_popup_gtk.cc',
             'browser/views/autocomplete/autocomplete_popup_gtk.h'
           ],
         }],
-        ['OS=="freebsd"', {
-          'dependencies': [
-            '../build/linux/system.gyp:gtk',
-            '../build/linux/system.gyp:nss',
-          ],
-        }],
         ['OS=="mac"', {
           'sources!': [
             'browser/automation/automation_provider_list_generic.cc',
@@ -2996,7 +2990,7 @@
                 ['exclude', '^browser/browser_list_gtk.cc'],
               ],
             }],
-            ['OS=="linux" and toolkit_views==0', {
+            ['(OS=="linux" or OS=="freebsd") and toolkit_views==0', {
               'sources/': [
                 ['include', '^browser/printing/print_dialog_gtk.cc'],
                 ['include', '^browser/printing/print_dialog_gtk.h'],
@@ -3101,7 +3095,7 @@
             '../third_party/WebKit/WebCore/WebCore.gyp/WebCore.gyp:webcore',
           ],
         }],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'sources': [
             'browser/gtk/sync_setup_wizard_gtk.cc',
             'browser/gtk/sync_setup_wizard_gtk.h',
@@ -3360,6 +3354,7 @@
         'renderer/renderer_histogram_snapshots.h',
         'renderer/renderer_main.cc',
         'renderer/renderer_main_platform_delegate.h',
+        'renderer/renderer_main_platform_delegate_freebsd.cc',
         'renderer/renderer_main_platform_delegate_linux.cc',
         'renderer/renderer_main_platform_delegate_mac.mm',
         'renderer/renderer_main_platform_delegate_win.cc',
@@ -3415,6 +3410,21 @@
             '../build/linux/system.gyp:gtk',
             '../sandbox/sandbox.gyp:sandbox',
           ],
+	  # You can't use 'sources!' here because the 'sources/' rules above
+	  # are applied second and override the choices here.
+	  'sources/': [
+            [ 'exclude', '^renderer/renderer_main_platform_delegate_freebsd.cc$' ],
+                ],
+        }],
+	# FreeBSD-specific rules.
+        ['OS=="freebsd"', {
+          'dependencies': [
+            '../build/linux/system.gyp:gtk',
+          ],
+	  # You can't use 'sources!' here because the 'sources/' rules above
+	  # are applied second and override the choices here.
+	  'sources/': [
+            [ 'exclude', '^renderer/renderer_main_platform_delegate_linux.cc$' ],	  ],
         }],
         # Windows-specific rules.
         ['OS=="win"', {
@@ -3456,7 +3466,7 @@
         '..',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
           ],
@@ -4113,7 +4123,7 @@
         'test/ui_test_utils_win.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
           ],
@@ -4158,7 +4168,7 @@
         'test/ui/ui_test_suite.h',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
           ],
@@ -4187,7 +4197,7 @@
         'test/unit/run_all_unittests.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             # Needed for the following #include chain:
             #   test/unit/run_all_unittests.cc
@@ -4222,7 +4232,7 @@
         'test/automated_ui_tests/automated_ui_tests.h',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
           ],
@@ -4310,7 +4320,7 @@
         'worker/worker_uitest.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS=="freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -4831,7 +4841,7 @@
             '../sandbox/sandbox.gyp:*',
           ],
         }],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'conditions': [
             [ 'gcc_version==44', {
               # Avoid gcc 4.4 strict aliasing issues in stl_tree.h when
@@ -5020,7 +5030,7 @@
         'test/startup/startup_test.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -5071,7 +5081,7 @@
             '../third_party/tcmalloc/tcmalloc.gyp:tcmalloc',
           ],
         },],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
           ],
@@ -5126,7 +5136,7 @@
         'test/page_cycler/page_cycler_test.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -5164,7 +5174,7 @@
         'test/tab_switching/tab_switching_test.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -5198,7 +5208,7 @@
         'test/memory_test/memory_test.cc',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk',
             '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -5363,7 +5373,7 @@
         'sync_proto',
       ],
       'conditions': [
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'sources!': [
             'browser/sync/notifier/base/network_status_detector_task_mt.cc',
           ],
@@ -5446,7 +5456,7 @@
             'browser/sync/util/data_encryption_unittest.cc',
           ],
         }],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk'
           ],
@@ -5560,7 +5570,7 @@
         'browser/sync/util/fast_dump.h',
         'browser/sync/util/path_helpers.cc',
         'browser/sync/util/path_helpers.h',
-        'browser/sync/util/path_helpers_linux.cc',
+#        'browser/sync/util/path_helpers_linux.cc',
         'browser/sync/util/path_helpers_mac.cc',
         'browser/sync/util/path_helpers_posix.cc',
         'browser/sync/util/path_helpers_win.cc',
@@ -5595,7 +5605,7 @@
             'browser/sync/util/data_encryption.h',
           ],
         }],
-        ['OS=="linux"', {
+        ['OS=="linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gtk'
           ],
@@ -6343,7 +6353,7 @@
             'test/perf/url_parse_perftest.cc',
           ],
           'conditions': [
-            ['OS=="linux"', {
+            ['OS=="linux" or OS == "freebsd"', {
               'dependencies': [
                 '../build/linux/system.gyp:gtk',
                 '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -6458,7 +6468,7 @@
             '<@(browser_tests_sources)',
           ],
           'conditions': [
-            ['OS=="linux"', {
+            ['OS=="linux" or OS == "freebsd"', {
               'dependencies': [
                 '../build/linux/system.gyp:gtk',
                 '../tools/xdisplaycheck/xdisplaycheck.gyp:xdisplaycheck',
@@ -6474,7 +6484,7 @@
                 '<@(browser_tests_sources_views_specific)',
               ],
             }],
-            ['OS=="linux" and toolkit_views==0', {
+            ['(OS=="linux" or OS == "freebsd") and toolkit_views==0', {
               'sources': [
                 '<@(browser_tests_sources_gtk_specific)',
               ],
@@ -6705,7 +6715,7 @@
             ],
             'conditions': [
               # Plugin code.
-              ['OS=="linux" or OS=="win"', {
+              ['OS=="linux" or OS == "freebsd" or OS=="win"', {
                 'dependencies': [
                   'plugin',
                  ],
@@ -6714,7 +6724,7 @@
                 ],
               }],
               # Linux-specific rules.
-              ['OS=="linux"', {
+              ['OS=="linux" or OS == "freebsd"', {
                  'dependencies': [
                    '../build/linux/system.gyp:gtk',
                  ],
diff --git chrome/common/child_process_host.cc chrome/common/child_process_host.cc
index d4a9eda..8432b84 100644
